Subject: Re: Avery Pennarun's git-subtree?

From: Jakub Narebski <[email-masked]>
Date: Mon, 26 Jul 2010 10:51:38 +0200

On Sat, 24 Jul 2010 00:50, Avery Pennarun wrote:
> On Fri, Jul 23, 2010 at 11:19 AM, Marc Branchaud <[email-masked]> wrote:
>> On 10-07-22 03:41 PM, Avery Pennarun wrote:
>>> 1) Sometimes I want to clone only some subdirs of a project
>>> 2) Sometimes I don't want the entire history because it's too big.
>>> 3) Super huge git repositories start to degrade in performance.
>>
>> The reason we turned to submodules is precisely to deal with repository size.
> 
> I believe that's very common.
> 
> However, I wonder whether that's actually a good reason for git to
> develop better submodules, or actually just a good reason for git to
> get better support for handling huge repositories.
> 
> My bup project (http://github.com/apenwarr/bup) is all about huge
> repositories.  It handles repositories with hundreds of gigabytes, and
> trees containing millions of files (entire filesystems), quite nicely.
>  Of course, it's not a version control system, so it won't solve your
> problems.  It's just evidence that large repositories are actually
> quite manageable without changing the fundamentals of git.

There is also git-bigfiles project, although it is more about large
[binary] files than large repositories per se (many files, long history).

Note that with 'bup' you might not see problems with large repositories
because it does not examine code paths that are slow in large repositories
(gc, log, path-delimited log).

>>  Our code base encompasses the entire FreeBSD tree plus different versions of
>> the Linux kernel, along with various third-party libraries & apps.  You don't
>> need everything to build a given product (a FreeBSD product doesn't use any
>> Linux kernels, for example) but because all the products share common code we
>> need to be able to branch and tag the common code along with the uncommon code.

Sidenote: I have noticed there very important ability of submodules, which
git-subtree lacks, or at least doesn't have it directly, namely ability
to tag in submodule separately of tagging superproject as whole (so e.g.
superproject v1.6.2 includes subproject 'foo' v0.99 which is foo/v0.99
tag in superproject).
 
>> So a straight "git clone" that would need to fetch all of FreeBSD plus 4
>> different Linux kernels and check all that out is a major problem, especially
>> for our automated build system (which could definitely be implemented better,
>> but still).
> 
> To be absolutely pedantic, the four linux kernels likely share most of
> their objects and so you're only paying the cost (at least during
> fetch) of including it once :)
> 
> (If you're actually using git-submodule and each copy of the kernel is
> its own module, then it might be cloning the kernel four times
> separately, in which case the objects *don't* get shared, so this ends
> up being much more expensive than it should be.  That could be fixed
> by slightly improving git-submodule to share some objects rather than
> rearchitecting it though.)

This issue is orthogonal to the fact of using submodules, it is a matter
of setting up alternates to share object storage.
 
>> In truth it's the checkout that takes the most time by far,
>> though commands like git-status also take inconveniently long.
> 
> Yeah, git could stand to be optimized a bit here.  And since Windows
> stats files about 10x slower than Linux, this problem occurs about 10x
> sooner on Windows, which makes using git on Windows (which sadly I
> have to do sometimes) extremely painful compared to Linux.
> 
> IMHO, the correct answer here is to have an inotify-based daemon prod
> at the .git/index automatically when files get updated, so that git
> itself doesn't have to stat/readdir through the entire tree in order
> to do any of its operations.  (Windows also has something like inotify
> that would work.)  If you had this, then git
> status/diff/checkout/commit would be just as fast with zillions of
> files as with 10 files.  Sooner or later, if nobody implements this, I
> promise I'll get around to it since inotify is actually easy to code
> for :)

IIUC the problem is that inotify is not automatically recursive, so
daemon would have to take care of adding inotify trigger to each newly
created subdirectory.

> Also note that the only reason submodules are faster here is that
> they're ignoring possibly important changes.  Notably, when you do
> 'git status' from the top level, it won't warn you if you have any
> not-yet-committed files in any of your submodules.  Personally, I
> consider that to be really important information, but to obtain it
> would make 'git status' take just as long as without submodules, so
> you wouldn't get any benefit.  (I think nowadays there's a way to get
> this recursive status information if you want it, but it'll be slow of
> course.)

Errr... didn't it got improved in recent git?  I think git-status now
includes information about submodules if configured so / unless configured
otherwise.  Isn't it?

>> We chose git-submodule over git-subtree mainly because git-submodule lets us
>> selectively checkout different parts of our code.  (AFAIK sparse checkouts
>> aren't yet an option.)

Sparse checkouts are here, IIRC, but they do not solve problem of disk
space (they are still in repository, even if not checked out), and speed
(they still need to be fetched, even if not checked out).

> Fair enough.  If you could confirm or deny my theory that this is
> *entirely* a performance related concern (as opposed to disk space /
> download time), that would be helpful.
> 
>> We didn't really consider git-subtree because it's
>> not an official part of git, and we didn't want to have to teach (and nag)
>> all our developers to install and maintain it in addition to keeping up with
>> git itself.
> 
> Arguably, this is a vote for including git-subtree into the core
> (which was Bryan's point when he started this thread); it obviously is
> being rejected sometimes by git users simply because it's not in the
> core, even though it could help them.

Well, patch management interfaces such as StGIT, Guilt and TopGit are
also outside git code (and should be), same with GUI tools such as qgit.
That shouldn't prevent people from using them ;-)

But I am all for having git-subtree in core: we have git-remote, haven't
we?  Besides git-subtree fits some workflows better than git-submodule
(and vice versa).

-- 
Jakub Narebski
Poland